#
# Conditional build:
%bcond_without	tests	# unit tests

%define		module	blockdiag
Summary:	Blockdiag generate block-diagram image file from spec-text file
Summary(pl.UTF-8):	Generowanie obrazków diagramów blokowych z opisu tekstowego
Name:		python3-%{module}
Version:	3.0.0
Release:	2
License:	Apache v2.0
Group:		Libraries/Python
#Source0Download: https://pypi.org/simple/blockdiag/
Source0:	https://files.pythonhosted.org/packages/source/b/blockdiag/%{module}-%{version}.tar.gz
# Source0-md5:	e1bfc69b83254ad3565c572ff4b3ad97
# https://github.com/blockdiag/blockdiag/pull/175.patch
Patch0:		blockdiag-pytest.patch
# https://github.com/blockdiag/blockdiag/pull/179.patch
Patch1:		blockdiag-pillow10.patch
Patch2:		blockdiag-pillow10-setup.patch
URL:		http://blockdiag.com/
BuildRequires:	python3-build
BuildRequires:	python3-installer
BuildRequires:	python3-modules >= 1:3.7
BuildRequires:	python3-setuptools
%if %{with tests}
BuildRequires:	python3-docutils
BuildRequires:	python3-funcparserlib >= 1.0.0
BuildRequires:	python3-pillow >= 3.1.0
BuildRequires:	python3-pytest
BuildRequires:	python3-reportlab
BuildRequires:	python3-webcolors
%endif
BuildRequires:	rpmbuild(macros) >= 1.714
BuildRequires:	sed >= 4.0
Requires:	python3-modules >= 1:3.7
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
blockdiag generates block-diagram image file from spec-text file.

Features:
- Generate block-diagram from dot like text (basic feature).
- Multilingualization for node-label (UTF-8 only).

%description -l pl.UTF-8
blockdiag generuje pliki obrazów diagramów blokowych z tekstowych
plików opisu.

Funkcje:
- generowanie diagramów z tekstu w stylu dot (podstawowa funkcja).
- obsługa wielu języków dla etykiet węzłów (tylko UTF-8).

%prep
%setup -q -n %{module}-%{version}
%patch -P0 -p1
%patch -P1 -p1
%patch -P2 -p1

# contains Pillow<10 dependency
%{__rm} -r src/blockdiag.egg-info

%build
# although project uses just setup.py, use PEP-517 build in order to get metadata for tests
%py3_build_pyproject

%if %{with tests}
%{__python3} -m zipfile -e build-3/*.whl build-3-test
# disable tests requiring network:
#  test_command.py::TestBlockdiagApp::test_app_cleans_up_images
#  test_generate_diagram.py::test_generate_with_separate[.../diagrams/node_icon.diag-svg-options260]
PYTHONPATH=$(pwd)/build-3-test \
PYTEST_DISABLE_PLUGIN_AUTOLOAD=1 \
%{__python3} -m pytest src/blockdiag/tests -k 'not test_app_cleans_up_images and not test_generate_with_separate'
%endif

%install
rm -rf $RPM_BUILD_ROOT

%py3_install_pyproject

%{__rm} -r $RPM_BUILD_ROOT%{py3_sitescriptdir}/blockdiag/tests

%{__mv} $RPM_BUILD_ROOT%{_bindir}/{blockdiag,blockdiag-3}
ln -s blockdiag-3 $RPM_BUILD_ROOT%{_bindir}/blockdiag
install -d $RPM_BUILD_ROOT%{_mandir}/man1
cp -p blockdiag.1 $RPM_BUILD_ROOT%{_mandir}/man1/blockdiag-3.1
echo '.so blockdiag-3.1' >$RPM_BUILD_ROOT%{_mandir}/man1/blockdiag.1

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc CHANGES.rst README.rst
%attr(755,root,root) %{_bindir}/blockdiag
%attr(755,root,root) %{_bindir}/blockdiag-3
%{py3_sitescriptdir}/blockdiag
%{py3_sitescriptdir}/blockdiag-%{version}.dist-info
%{_mandir}/man1/blockdiag.1*
%{_mandir}/man1/blockdiag-3.1*
%changelog
* Mon Jul 14 2025 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/python3-blockdiag.git;a=log;h=master

* Sun Jul 13 2025 Jakub Bogusz <qboosh@pld-linux.org> 3dd34b6
- apply fixes for Pillow 10+ and pytest instead of nose; release 2

* Sun Apr 27 2025 Jan Rękorajski <baggins@pld-linux.org> 486b65c
- updated files

* Sun Apr 27 2025 Jan Rękorajski <baggins@pld-linux.org> 03892bd
- up to 3.0.0, tests semm to be broken

* Mon Mar 17 2025 Jakub Bogusz <qboosh@pld-linux.org> 26df487
- updated reportlab module name

* Tue Mar 11 2025 Jan Rękorajski <baggins@pld-linux.org> 1a39215
- doc/test rebuild for python 3.13

* Mon Mar 10 2025 Jan Rękorajski <baggins@pld-linux.org> 89f622a
- python 3.13 rebuild

* Wed Mar 30 2022 Jan Rękorajski <baggins@pld-linux.org> be120b8
- rebuild with tests and docs

* Fri Mar 25 2022 Jan Rękorajski <baggins@pld-linux.org> d99b7a1
- rebuild with python 3.10

* Sat Feb 27 2021 Jan Rękorajski <baggins@pld-linux.org> 8ab73a4
- release 2 (by relup.sh)

* Sat Feb 06 2021 Jakub Bogusz <qboosh@pld-linux.org> cead4f0
- disable network tests

* Sat Feb 06 2021 Jakub Bogusz <qboosh@pld-linux.org> e163e41
- updated to 2.0.1 (python 3.5+) as python3-blockdiag.spec
- removed outdated tests patch

* Sat Feb 06 2021 Jakub Bogusz <qboosh@pld-linux.org> 0a2b7be
- updated to 1.5.4
- added python3- package, let default binary be py3
- added tests patch (fixes py2 tests with backports.configparser installed)

* Sun Nov 29 2015 Jacek Konieczny <jajcus@jajcus.net> 7ed0722
- BR: rpmbuild(macros) >= 1.710

* Sat Nov 28 2015 Jacek Konieczny <jajcus@jajcus.net> 05a7194
- release 2 (by relup.sh)

* Sat Nov 28 2015 Jacek Konieczny <jajcus@jajcus.net> 8c93baa
- automatic change: use py_build/py_install macros

* Wed Aug 01 2012 Łukasz Kieś <kiesiu@pld-linux.org> c3ab616
- more versioned requires
- no need of devel-tools

* Wed Aug 01 2012 Łukasz Kieś <kiesiu@pld-linux.org> 036f38e
- updated to 1.1.6

* Sun Feb 19 2012 Adam Gołębiowski <adamg@pld-linux.org> 0a88fb9
- updated to 1.1.3

* Thu Jan 12 2012 zbyniu <zbyniu@pld-linux.org> b122c2f
- up to 1.1.2

* Sun Dec 04 2011 Elan Ruusamäe <glen@pld-linux.org> e2a035c
- can do OrderedDict on py2.4 as well then

